/* Copyright 2014 - 2015 B+B SmartWorx. All rights reserved. */

/*jslint browser: true */
/*global $, Modernizr, alert, console, document, window */

var console = window.console || {};

console.log = console.log || function (msg) {
    'use strict';
    // FOR DEBUGGING: alert(msg);
};

// The document has been completely loaded.
$(document).ready(function () {
    'use strict';

    // Load polyfill when the web browser is missing support for HTML5 input types or HTML5 input attributes.
    Modernizr.load(
        [{
            test: Modernizr.inputtypes.number && Modernizr.input.min && Modernizr.input.max && Modernizr.input.step && Modernizr.input.required && Modernizr.input.autocomplete && Modernizr.input.pattern,
            yep: null,
            nope: ['../lib/jquery-validation/1.13.1/jquery.validate.min.js', '../lib/jquery-validation/1.13.1/additional-methods.min.js'],
            complete: function () {
                try {
                    if ($('#form').validate) {
                        $('#form').validate();
                    }
                } catch (err) {
                    console.log(err.message);
                }
            }
        }]
    );

    if ($('#restore').click) {
        $('#restore').click(function () {
            try {
                // Just reload the user-module's index.cgi to restore the current configuration.
                window.location.replace('index.cgi');
            } catch (err) {
                console.log(err.message);
            }
        });
    }

    if ($('#return').click) {
        $('#return').click(function () {
            try {
                var url_parts = window.location.href.split('/');
                if (url_parts.length > 0) {
                    if ('index.cgi' === url_parts[url_parts.length - 1]) {
                        // From the user-module's index.cgi page, go back to the main user-module page.
                        window.location.replace('/module.cgi');
                    } else if ('set.cgi' === url_parts[url_parts.length - 1]) {
                        // From the user-module's set.cgi page, go back to the main user-module configuration page.
                        window.location.replace('index.cgi');
                    } else {
                        // If it is something unexpected, go back to the router's main page.
                        window.location.replace('/');
                    }
                }
            } catch (err) {
                console.log(err.message);
            }
        });
    }
});